<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReadEnterpriseLegalPersonByCompanyNameExactMatchReplyType
 * StructType
 * @subpackage Structs
 */
class ReadEnterpriseLegalPersonByCompanyNameExactMatchReplyType extends AbstractStructBase
{
    /**
     * The Enterprise
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: datamodel:Enterprise
     * @var \StructType\EnterpriseType[]
     */
    public $Enterprise;
    /**
     * Constructor method for ReadEnterpriseLegalPersonByCompanyNameExactMatchReplyType
     * @uses ReadEnterpriseLegalPersonByCompanyNameExactMatchReplyType::setEnterprise()
     * @param \StructType\EnterpriseType[] $enterprise
     */
    public function __construct(array $enterprise = array())
    {
        $this
            ->setEnterprise($enterprise);
    }
    /**
     * Get Enterprise value
     * @return \StructType\EnterpriseType[]|null
     */
    public function getEnterprise()
    {
        return $this->Enterprise;
    }
    /**
     * This method is responsible for validating the values passed to the setEnterprise method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEnterprise method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEnterpriseForArrayConstraintsFromSetEnterprise(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $readEnterpriseLegalPersonByCompanyNameExactMatchReplyTypeEnterpriseItem) {
            // validation for constraint: itemType
            if (!$readEnterpriseLegalPersonByCompanyNameExactMatchReplyTypeEnterpriseItem instanceof \StructType\EnterpriseType) {
                $invalidValues[] = is_object($readEnterpriseLegalPersonByCompanyNameExactMatchReplyTypeEnterpriseItem) ? get_class($readEnterpriseLegalPersonByCompanyNameExactMatchReplyTypeEnterpriseItem) : sprintf('%s(%s)', gettype($readEnterpriseLegalPersonByCompanyNameExactMatchReplyTypeEnterpriseItem), var_export($readEnterpriseLegalPersonByCompanyNameExactMatchReplyTypeEnterpriseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Enterprise property can only contain items of type \StructType\EnterpriseType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Enterprise value
     * @throws \InvalidArgumentException
     * @param \StructType\EnterpriseType[] $enterprise
     * @return \StructType\ReadEnterpriseLegalPersonByCompanyNameExactMatchReplyType
     */
    public function setEnterprise(array $enterprise = array())
    {
        // validation for constraint: array
        if ('' !== ($enterpriseArrayErrorMessage = self::validateEnterpriseForArrayConstraintsFromSetEnterprise($enterprise))) {
            throw new \InvalidArgumentException($enterpriseArrayErrorMessage, __LINE__);
        }
        $this->Enterprise = $enterprise;
        return $this;
    }
    /**
     * Add item to Enterprise value
     * @throws \InvalidArgumentException
     * @param \StructType\EnterpriseType $item
     * @return \StructType\ReadEnterpriseLegalPersonByCompanyNameExactMatchReplyType
     */
    public function addToEnterprise(\StructType\EnterpriseType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EnterpriseType) {
            throw new \InvalidArgumentException(sprintf('The Enterprise property can only contain items of type \StructType\EnterpriseType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Enterprise[] = $item;
        return $this;
    }
}
